##// END OF EJS Templates
Fixed: Remove empty .ssh directories
drtyhlpr -
r124:b9b25fc2967a
parent child
Show More
@@ -1,621 +1,631
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie" and "stretch" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 10+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
46 46 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
47 47 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
48 48 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
49 49
50 50 # Debian release
51 51 RELEASE=${RELEASE:=jessie}
52 52 KERNEL_ARCH=${KERNEL_ARCH:=arm}
53 53 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
54 54 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
55 55 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
56 56 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
57 57 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
58 58 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
59 59
60 60 # URLs
61 61 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
62 62 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
63 63 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm80211/brcm}
64 64 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
65 65 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
66 66 UBOOT_URL=${UBOOT_URL:=git://git.denx.de/u-boot.git}
67 67
68 68 # Build directories
69 69 BASEDIR="$(pwd)/images/${RELEASE}"
70 70 BUILDDIR="${BASEDIR}/build"
71 71
72 72 # Chroot directories
73 73 R="${BUILDDIR}/chroot"
74 74 ETC_DIR="${R}/etc"
75 75 LIB_DIR="${R}/lib"
76 76 BOOT_DIR="${R}/boot/firmware"
77 77 KERNEL_DIR="${R}/usr/src/linux"
78 78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79 79
80 80 # Firmware directory: Blank if download from github
81 81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82 82
83 83 # General settings
84 84 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 85 PASSWORD=${PASSWORD:=raspberry}
86 86 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 87 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 88 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 89 EXPANDROOT=${EXPANDROOT:=true}
90 90
91 91 # Keyboard settings
92 92 XKB_MODEL=${XKB_MODEL:=""}
93 93 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 94 XKB_VARIANT=${XKB_VARIANT:=""}
95 95 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 96
97 97 # Network settings (DHCP)
98 98 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 99
100 100 # Network settings (static)
101 101 NET_ADDRESS=${NET_ADDRESS:=""}
102 102 NET_GATEWAY=${NET_GATEWAY:=""}
103 103 NET_DNS_1=${NET_DNS_1:=""}
104 104 NET_DNS_2=${NET_DNS_2:=""}
105 105 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 106 NET_NTP_1=${NET_NTP_1:=""}
107 107 NET_NTP_2=${NET_NTP_2:=""}
108 108
109 109 # APT settings
110 110 APT_PROXY=${APT_PROXY:=""}
111 111 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 112
113 113 # Feature settings
114 114 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 115 ENABLE_IPV6=${ENABLE_IPV6:=true}
116 116 ENABLE_SSHD=${ENABLE_SSHD:=true}
117 117 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
118 118 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
119 119 ENABLE_SOUND=${ENABLE_SOUND:=true}
120 120 ENABLE_DBUS=${ENABLE_DBUS:=true}
121 121 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
122 122 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
123 123 ENABLE_XORG=${ENABLE_XORG:=false}
124 124 ENABLE_WM=${ENABLE_WM:=""}
125 125 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
126 126 ENABLE_USER=${ENABLE_USER:=true}
127 127 USER_NAME=${USER_NAME:="pi"}
128 128 ENABLE_ROOT=${ENABLE_ROOT:=false}
129 129
130 130 # SSH settings
131 131 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
132 132 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
133 133 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
134 134 SSH_ROOT_AUTHORIZED_KEYS=${SSH_ROOT_AUTHORIZED_KEYS:=""}
135 135 SSH_USER_AUTHORIZED_KEYS=${SSH_USER_AUTHORIZED_KEYS:=""}
136 136 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
137 137 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
138 138
139 139 # Advanced settings
140 140 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
141 141 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
142 142 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
143 143 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
144 144 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
145 145 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
146 146 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
147 147 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
148 148 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
149 149
150 150 # Kernel compilation settings
151 151 BUILD_KERNEL=${BUILD_KERNEL:=false}
152 152 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
153 153 KERNEL_THREADS=${KERNEL_THREADS:=1}
154 154 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
155 155 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
156 156 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
157 157
158 158 # Kernel compilation from source directory settings
159 159 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
160 160 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
161 161 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
162 162 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
163 163
164 164 # Reduce disk usage settings
165 165 REDUCE_APT=${REDUCE_APT:=true}
166 166 REDUCE_DOC=${REDUCE_DOC:=true}
167 167 REDUCE_MAN=${REDUCE_MAN:=true}
168 168 REDUCE_VIM=${REDUCE_VIM:=false}
169 169 REDUCE_BASH=${REDUCE_BASH:=false}
170 170 REDUCE_HWDB=${REDUCE_HWDB:=true}
171 171 REDUCE_SSHD=${REDUCE_SSHD:=true}
172 172 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
173 173
174 174 # Encrypted filesystem settings
175 175 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
176 176 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
177 177 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
178 178 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
179 179 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
180 180
181 181 # Stop the Crypto Wars
182 182 DISABLE_FBI=${DISABLE_FBI:=false}
183 183
184 184 # Chroot scripts directory
185 185 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
186 186
187 187 # Packages required in the chroot build environment
188 188 APT_INCLUDES=${APT_INCLUDES:=""}
189 189 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
190 190
191 191 # Packages required for bootstrapping
192 192 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc"
193 193 MISSING_PACKAGES=""
194 194
195 195 set +x
196 196
197 197 # Set Raspberry Pi model specific configuration
198 198 if [ "$RPI_MODEL" = 2 ] ; then
199 199 DTB_FILE=${RPI2_DTB_FILE}
200 200 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
201 201 elif [ "$RPI_MODEL" = 3 ] ; then
202 202 DTB_FILE=${RPI3_DTB_FILE}
203 203 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
204 204 BUILD_KERNEL=true
205 205 else
206 206 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
207 207 exit 1
208 208 fi
209 209
210 210 # Check if the internal wireless interface is supported by the RPi model
211 211 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" != 3 ] ; then
212 212 echo "error: The selected Raspberry Pi model has no internal wireless interface"
213 213 exit 1
214 214 fi
215 215
216 216 # Set compiler packages and build RPi2/3 Linux kernel if required by Debian release
217 217 if [ "$RELEASE" = "jessie" ] ; then
218 218 COMPILER_PACKAGES="linux-compiler-gcc-4.8-arm g++ make bc"
219 219 elif [ "$RELEASE" = "stretch" ] ; then
220 220 COMPILER_PACKAGES="linux-compiler-gcc-5-arm g++ make bc"
221 221 BUILD_KERNEL=true
222 222 else
223 223 echo "error: Debian release ${RELEASE} is not supported!"
224 224 exit 1
225 225 fi
226 226
227 227 # Add packages required for kernel cross compilation
228 228 if [ "$BUILD_KERNEL" = true ] ; then
229 229 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
230 230 fi
231 231
232 232 # Add libncurses5 to enable kernel menuconfig
233 233 if [ "$KERNEL_MENUCONFIG" = true ] ; then
234 234 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
235 235 fi
236 236
237 237 # Stop the Crypto Wars
238 238 if [ "$DISABLE_FBI" = true ] ; then
239 239 ENABLE_CRYPTFS=true
240 240 fi
241 241
242 242 # Add cryptsetup package to enable filesystem encryption
243 243 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
244 244 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
245 245 APT_INCLUDES="${APT_INCLUDES},cryptsetup"
246 246
247 247 if [ -z "$CRYPTFS_PASSWORD" ] ; then
248 248 echo "error: no password defined (CRYPTFS_PASSWORD)!"
249 249 exit 1
250 250 fi
251 251 ENABLE_INITRAMFS=true
252 252 fi
253 253
254 254 # Add initramfs generation tools
255 255 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
256 256 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
257 257 fi
258 258
259 259 # Add device-tree-compiler required for building the U-Boot bootloader
260 260 if [ "$ENABLE_UBOOT" = true ] ; then
261 261 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
262 262 fi
263 263
264 264 # Check if root SSH authorized keys file exists
265 265 if [ ! -z "$SSH_ROOT_AUTHORIZED_KEYS" ] ; then
266 266 if [ ! -f "$SSH_ROOT_AUTHORIZED_KEYS" ] ; then
267 267 echo "error: '$SSH_ROOT_AUTHORIZED_KEYS' specified SSH authorized keys file not found (SSH_ROOT_AUTHORIZED_KEYS)!"
268 268 exit 1
269 269 fi
270 270 fi
271 271
272 272 # Check if $USER_NAME SSH authorized keys file exists
273 273 if [ ! -z "$SSH_USER_AUTHORIZED_KEYS" ] ; then
274 274 if [ ! -f "$SSH_USER_AUTHORIZED_KEYS" ] ; then
275 275 echo "error: '$SSH_USER_AUTHORIZED_KEYS' specified SSH authorized keys file not found (SSH_USER_AUTHORIZED_KEYS)!"
276 276 exit 1
277 277 fi
278 278 fi
279 279
280 280 # Check if root SSH (v2) public key file exists
281 281 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
282 282 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
283 283 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
284 284 exit 1
285 285 fi
286 286 fi
287 287
288 288 # Check if $USER_NAME SSH (v2) public key file exists
289 289 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
290 290 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
291 291 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
292 292 exit 1
293 293 fi
294 294 fi
295 295
296 296 # Check if all required packages are installed on the build system
297 297 for package in $REQUIRED_PACKAGES ; do
298 298 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
299 299 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
300 300 fi
301 301 done
302 302
303 303 # If there are missing packages ask confirmation for install, or exit
304 304 if [ -n "$MISSING_PACKAGES" ] ; then
305 305 echo "the following packages needed by this script are not installed:"
306 306 echo "$MISSING_PACKAGES"
307 307
308 308 echo -n "\ndo you want to install the missing packages right now? [y/n] "
309 309 read confirm
310 310 [ "$confirm" != "y" ] && exit 1
311 311
312 312 # Make sure all missing required packages are installed
313 313 apt-get -qq -y install ${MISSING_PACKAGES}
314 314 fi
315 315
316 316 # Check if ./bootstrap.d directory exists
317 317 if [ ! -d "./bootstrap.d/" ] ; then
318 318 echo "error: './bootstrap.d' required directory not found!"
319 319 exit 1
320 320 fi
321 321
322 322 # Check if ./files directory exists
323 323 if [ ! -d "./files/" ] ; then
324 324 echo "error: './files' required directory not found!"
325 325 exit 1
326 326 fi
327 327
328 328 # Check if specified KERNELSRC_DIR directory exists
329 329 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
330 330 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
331 331 exit 1
332 332 fi
333 333
334 334 # Check if specified CHROOT_SCRIPTS directory exists
335 335 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
336 336 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
337 337 exit 1
338 338 fi
339 339
340 340 # Check if specified device mapping already exists (will be used by cryptsetup)
341 341 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
342 342 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
343 343 exit 1
344 344 fi
345 345
346 346 # Don't clobber an old build
347 347 if [ -e "$BUILDDIR" ] ; then
348 348 echo "error: directory ${BUILDDIR} already exists, not proceeding"
349 349 exit 1
350 350 fi
351 351
352 352 # Setup chroot directory
353 353 mkdir -p "${R}"
354 354
355 355 # Check if build directory has enough of free disk space >512MB
356 356 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
357 357 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
358 358 exit 1
359 359 fi
360 360
361 361 set -x
362 362
363 363 # Call "cleanup" function on various signals and errors
364 364 trap cleanup 0 1 2 3 6
365 365
366 366 # Add required packages for the minbase installation
367 367 if [ "$ENABLE_MINBASE" = true ] ; then
368 368 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
369 369 fi
370 370
371 371 # Add required locales packages
372 372 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
373 373 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
374 374 fi
375 375
376 376 # Add parted package, required to get partprobe utility
377 377 if [ "$EXPANDROOT" = true ] ; then
378 378 APT_INCLUDES="${APT_INCLUDES},parted"
379 379 fi
380 380
381 381 # Add dbus package, recommended if using systemd
382 382 if [ "$ENABLE_DBUS" = true ] ; then
383 383 APT_INCLUDES="${APT_INCLUDES},dbus"
384 384 fi
385 385
386 386 # Add iptables IPv4/IPv6 package
387 387 if [ "$ENABLE_IPTABLES" = true ] ; then
388 388 APT_INCLUDES="${APT_INCLUDES},iptables"
389 389 fi
390 390
391 391 # Add openssh server package
392 392 if [ "$ENABLE_SSHD" = true ] ; then
393 393 APT_INCLUDES="${APT_INCLUDES},openssh-server"
394 394 fi
395 395
396 396 # Add alsa-utils package
397 397 if [ "$ENABLE_SOUND" = true ] ; then
398 398 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
399 399 fi
400 400
401 401 # Add rng-tools package
402 402 if [ "$ENABLE_HWRANDOM" = true ] ; then
403 403 APT_INCLUDES="${APT_INCLUDES},rng-tools"
404 404 fi
405 405
406 406 # Add fbturbo video driver
407 407 if [ "$ENABLE_FBTURBO" = true ] ; then
408 408 # Enable xorg package dependencies
409 409 ENABLE_XORG=true
410 410 fi
411 411
412 412 # Add user defined window manager package
413 413 if [ -n "$ENABLE_WM" ] ; then
414 414 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
415 415
416 416 # Enable xorg package dependencies
417 417 ENABLE_XORG=true
418 418 fi
419 419
420 420 # Add xorg package
421 421 if [ "$ENABLE_XORG" = true ] ; then
422 422 APT_INCLUDES="${APT_INCLUDES},xorg"
423 423 fi
424 424
425 425 # Replace selected packages with smaller clones
426 426 if [ "$ENABLE_REDUCE" = true ] ; then
427 427 # Add levee package instead of vim-tiny
428 428 if [ "$REDUCE_VIM" = true ] ; then
429 429 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
430 430 fi
431 431
432 432 # Add dropbear package instead of openssh-server
433 433 if [ "$REDUCE_SSHD" = true ] ; then
434 434 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
435 435 fi
436 436 fi
437 437
438 438 # Configure kernel sources if no KERNELSRC_DIR
439 439 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
440 440 KERNELSRC_CONFIG=true
441 441 fi
442 442
443 443 # Configure reduced kernel
444 444 if [ "$KERNEL_REDUCE" = true ] ; then
445 445 KERNELSRC_CONFIG=false
446 446 fi
447 447
448 448 # Execute bootstrap scripts
449 449 for SCRIPT in bootstrap.d/*.sh; do
450 450 head -n 3 "$SCRIPT"
451 451 . "$SCRIPT"
452 452 done
453 453
454 454 ## Execute custom bootstrap scripts
455 455 if [ -d "custom.d" ] ; then
456 456 for SCRIPT in custom.d/*.sh; do
457 457 . "$SCRIPT"
458 458 done
459 459 fi
460 460
461 461 # Execute custom scripts inside the chroot
462 462 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
463 463 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
464 464 chroot_exec /bin/bash -x <<'EOF'
465 465 for SCRIPT in /chroot_scripts/* ; do
466 466 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
467 467 $SCRIPT
468 468 fi
469 469 done
470 470 EOF
471 471 rm -rf "${R}/chroot_scripts"
472 472 fi
473 473
474 474 # Remove apt-utils
475 475 if [ "$RELEASE" = "jessie" ] ; then
476 476 chroot_exec apt-get purge -qq -y --force-yes apt-utils
477 477 fi
478 478
479 479 # Generate required machine-id
480 480 MACHINE_ID=$(dbus-uuidgen)
481 481 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
482 482 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
483 483
484 484 # APT Cleanup
485 485 chroot_exec apt-get -y clean
486 486 chroot_exec apt-get -y autoclean
487 487 chroot_exec apt-get -y autoremove
488 488
489 489 # Unmount mounted filesystems
490 490 umount -l "${R}/proc"
491 491 umount -l "${R}/sys"
492 492
493 493 # Clean up directories
494 494 rm -rf "${R}/run/*"
495 495 rm -rf "${R}/tmp/*"
496 496
497 497 # Clean up files
498 498 rm -f "${ETC_DIR}/ssh/ssh_host_*"
499 499 rm -f "${ETC_DIR}/dropbear/dropbear_*"
500 500 rm -f "${ETC_DIR}/apt/sources.list.save"
501 501 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
502 502 rm -f "${ETC_DIR}/*-"
503 503 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
504 504 rm -f "${ETC_DIR}/resolv.conf"
505 505 rm -f "${R}/root/.bash_history"
506 506 rm -f "${R}/var/lib/urandom/random-seed"
507 507 rm -f "${R}/initrd.img"
508 508 rm -f "${R}/vmlinuz"
509 509 rm -f "${R}${QEMU_BINARY}"
510 510
511 # Remove root .ssh directory if it's empty
512 if [ -d "${R}/root/.ssh" ] ; then
513 rmdir --ignore-fail-on-non-empty "${R}/root/.ssh"
514 fi
515
516 # Remove $USER_NAME .ssh directory if it's empty
517 if [ -d "${R}/home/${USER_NAME}/.ssh" ] ; then
518 rmdir --ignore-fail-on-non-empty "${R}/home/${USER_NAME}/.ssh"
519 fi
520
511 521 # Calculate size of the chroot directory in KB
512 522 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
513 523
514 524 # Calculate the amount of needed 512 Byte sectors
515 525 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
516 526 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
517 527 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
518 528
519 529 # The root partition is EXT4
520 530 # This means more space than the actual used space of the chroot is used.
521 531 # As overhead for journaling and reserved blocks 25% are added.
522 532 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 25) \* 1024 \/ 512)
523 533
524 534 # Calculate required image size in 512 Byte sectors
525 535 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
526 536
527 537 # Prepare date string for image file name
528 538 DATE="$(date +%Y-%m-%d)"
529 539
530 540 # Prepare image file
531 541 if [ "$ENABLE_SPLITFS" = true ] ; then
532 542 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img" bs=512 count=${TABLE_SECTORS}
533 543 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
534 544 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img" bs=512 count=${TABLE_SECTORS}
535 545 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
536 546
537 547 # Write firmware/boot partition tables
538 548 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img" 2> /dev/null <<EOM
539 549 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
540 550 EOM
541 551
542 552 # Write root partition table
543 553 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img" 2> /dev/null <<EOM
544 554 ${TABLE_SECTORS},${ROOT_SECTORS},83
545 555 EOM
546 556
547 557 # Setup temporary loop devices
548 558 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img)"
549 559 ROOT_LOOP="$(losetup -o 1M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img)"
550 560 else # ENABLE_SPLITFS=false
551 561 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img" bs=512 count=${TABLE_SECTORS}
552 562 dd if=/dev/zero of="$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img" bs=512 count=0 seek=${IMAGE_SECTORS}
553 563
554 564 # Write partition table
555 565 sfdisk -q -L -uS -f "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img" 2> /dev/null <<EOM
556 566 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
557 567 ${ROOT_OFFSET},${ROOT_SECTORS},83
558 568 EOM
559 569
560 570 # Setup temporary loop devices
561 571 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img)"
562 572 ROOT_LOOP="$(losetup -o 65M -f --show $BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img)"
563 573 fi
564 574
565 575 if [ "$ENABLE_CRYPTFS" = true ] ; then
566 576 # Create dummy ext4 fs
567 577 mkfs.ext4 "$ROOT_LOOP"
568 578
569 579 # Setup password keyfile
570 580 echo -n ${CRYPTFS_PASSWORD} > .password
571 581 chmod 600 .password
572 582
573 583 # Initialize encrypted partition
574 584 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
575 585
576 586 # Open encrypted partition and setup mapping
577 587 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
578 588
579 589 # Secure delete password keyfile
580 590 shred -zu .password
581 591
582 592 # Update temporary loop device
583 593 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
584 594
585 595 # Wipe encrypted partition (encryption cipher is used for randomness)
586 596 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
587 597 fi
588 598
589 599 # Build filesystems
590 600 mkfs.vfat "$FRMW_LOOP"
591 601 mkfs.ext4 "$ROOT_LOOP"
592 602
593 603 # Mount the temporary loop devices
594 604 mkdir -p "$BUILDDIR/mount"
595 605 mount "$ROOT_LOOP" "$BUILDDIR/mount"
596 606
597 607 mkdir -p "$BUILDDIR/mount/boot/firmware"
598 608 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
599 609
600 610 # Copy all files from the chroot to the loop device mount point directory
601 611 rsync -a "${R}/" "$BUILDDIR/mount/"
602 612
603 613 # Unmount all temporary loop devices and mount points
604 614 cleanup
605 615
606 616 # Create block map file(s) of image(s)
607 617 if [ "$ENABLE_SPLITFS" = true ] ; then
608 618 # Create block map files for "bmaptool"
609 619 bmaptool create -o "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.bmap" "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img"
610 620 bmaptool create -o "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.bmap" "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img"
611 621
612 622 # Image was successfully created
613 623 echo "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
614 624 echo "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
615 625 else
616 626 # Create block map file for "bmaptool"
617 627 bmaptool create -o "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.bmap" "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img"
618 628
619 629 # Image was successfully created
620 630 echo "$BASEDIR/${DATE}-rpi${RPI_MODEL}-${RELEASE}.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
621 631 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant